/*
 *  Copyright (C) 2006-2007 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef CONVERTER_H
#define CONVERTER_H

#include <fx.h>

class converter {

private:
	unsigned int	_channels;
	unsigned int	_prec;
	unsigned int	_sampleSize;

	FXuchar	_int;
	FXuint	_fract;
	FXuchar	_iRate;
	FXuint	_fRate;

	int	_data;

	char	*_buffer;
	unsigned int	_bufsize;

private:
	converter();
	converter(const converter&);
	converter& operator=(const converter&);

	template <class T>
	int _convert(T* buf, unsigned int len);

public:
	converter(int srIn, int srOut, unsigned int size, unsigned int channels, unsigned int prec);
	~converter();

	/// Get pointer to buffer
	char* buffer() { return (char*)_buffer+_data; }

	/// Get buffer size
	int bufSize() { return _bufsize-_data; }

	/// Do the conversion
	int convert(char* out, unsigned int len);
};

#endif
