/*
 *  Copyright (C) 2006-2008 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "inputPlugin.h"

inputPlugin::inputPlugin(FXApp* app, const char name[], const unsigned char iconType[]) :
	_app(app),
	_name(name),
	_time(0),
	_songLoaded(false) {

	_icon=new FXGIFIcon(_app, iconType);
	_icon->create();
}

inputPlugin::~inputPlugin() {

	delete _icon;
}

FXint inputPlugin::filter(FXString* files, FXint items) {

	FXint j=0;
	for (int i=0; i<items; i++) {
		if (FXPath::match(ext(), FXPath::name(files[i]),
		FILEMATCH_FILE_NAME|FILEMATCH_NOESCAPE|FILEMATCH_CASEFOLD))
			files[j++]=files[i];
	}
	return j;
}
