/*
 *  Copyright (C) 2006-2009 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "mpc.h"

#ifdef HAVE_LIBMPCDEC

#include "utils.h"
#include "tag.h"

// created by reswrap from file musepack.gif
extern const unsigned char iconMpc[417]={
  0x47,0x49,0x46,0x38,0x39,0x61,0x10,0x00,0x10,0x00,0xf5,0x3c,0x00,0xc6,0x41,0x00,
  0xc6,0x45,0x00,0xc6,0x49,0x00,0xce,0x45,0x00,0xce,0x4d,0x00,0xce,0x51,0x00,0xce,
  0x59,0x00,0xce,0x61,0x08,0xce,0x65,0x10,0xce,0x61,0x18,0xd6,0x69,0x18,0xd6,0x65,
  0x21,0xd6,0x6d,0x21,0xd6,0x6d,0x29,0xd6,0x71,0x21,0xd6,0x71,0x29,0xd6,0x75,0x31,
  0xd6,0x79,0x31,0xd6,0x7d,0x39,0xd6,0x7d,0x42,0xd6,0x82,0x39,0xd6,0x86,0x4a,0xd6,
  0x8a,0x4a,0xd6,0x8e,0x52,0xde,0x8e,0x52,0xde,0x8e,0x5a,0xde,0x92,0x5a,0xd6,0x96,
  0x63,0xde,0x96,0x63,0xde,0x9a,0x63,0xde,0x9e,0x6b,0xde,0x9e,0x73,0xde,0xa2,0x73,
  0xde,0xa6,0x7b,0xde,0xaa,0x84,0xde,0xb2,0x8c,0xe7,0xb2,0x8c,0xe7,0xb2,0x94,0xe7,
  0xba,0x9c,0xe7,0xbe,0xa5,0xe7,0xc3,0xa5,0xe7,0xc7,0xad,0xe7,0xcb,0xad,0xe7,0xcb,
  0xb5,0xe7,0xd3,0xbd,0xef,0xd3,0xc6,0xef,0xd7,0xc6,0xef,0xdb,0xce,0xef,0xdf,0xd6,
  0xef,0xe3,0xd6,0xef,0xe7,0xde,0xf7,0xe3,0xd6,0xef,0xeb,0xe7,0xef,0xef,0xe7,0xef,
  0xef,0xef,0xef,0xf3,0xef,0xef,0xf7,0xf7,0xef,0xfb,0xff,0xff,0xf7,0xef,0xf7,0xff,
  0xff,0xff,0xff,0xff,0xab,0xac,0xad,0x00,0x00,0x00,0x00,0x00,0x00,0x21,0xf9,0x04,
  0x01,0x00,0x00,0x3d,0x00,0x2c,0x00,0x00,0x00,0x00,0x10,0x00,0x10,0x00,0x00,0x06,
  0xbe,0xc0,0xdd,0x8e,0x44,0xf0,0x08,0x8f,0x3b,0x0e,0xc1,0x74,0x94,0x25,0x0a,0x05,
  0x17,0xd2,0x65,0x28,0x2c,0x6a,0x42,0x14,0x41,0x41,0x08,0x21,0x45,0x84,0x04,0xe1,
  0xc4,0xdb,0x7d,0x08,0x22,0xc3,0x24,0x77,0xc4,0x14,0xc0,0x9b,0x72,0x85,0xf0,0x72,
  0x20,0x68,0x42,0x1c,0xe4,0xf0,0x32,0x3c,0xca,0x0f,0x07,0x3b,0x73,0x2f,0x42,0x36,
  0x08,0x0a,0x3b,0x0f,0x06,0x3a,0x3b,0x07,0x0c,0x3b,0x20,0x03,0x2b,0x42,0x32,0x06,
  0x10,0x3b,0x18,0x02,0x33,0x31,0x05,0x12,0x3b,0x25,0x01,0x24,0x42,0x2f,0x04,0x15,
  0x3b,0x21,0x01,0x28,0x2e,0x04,0x18,0x3b,0x2a,0x03,0x1f,0x42,0x2d,0x04,0x1a,0x3b,
  0x26,0x01,0x21,0x2b,0x03,0x1d,0x3b,0xac,0x17,0x42,0xbb,0x46,0x2c,0xb5,0x2b,0x00,
  0x5e,0x9d,0x11,0x59,0xb9,0x3b,0x9d,0x12,0x19,0x04,0x23,0x3b,0x34,0x08,0x90,0xb7,
  0x00,0xd2,0x34,0x09,0x08,0x04,0x03,0x25,0x42,0x81,0x78,0x23,0x03,0x4c,0x37,0x0d,
  0x03,0x28,0x26,0x30,0x42,0x14,0x05,0xeb,0xa9,0x29,0x3b,0x36,0x2b,0x4c,0x48,0x1a,
  0x04,0x2c,0x49,0xf8,0x48,0x47,0x37,0xa8,0xaa,0x3b,0x2c,0xd0,0x41,0x12,0x04,0x00,
  0x3b
  };

#define EXT	"*.mpc"

#define CREDITS		"Musepack\nCopyright \302\251 The Musepack Development Team"
#define LINK		"http://www.musepack.com/"

const char mpc::name[]="Musepack";

/*****************************************************************/

int mpc::fillBuffer(char* buffer, const unsigned int bufferSize, const unsigned int seconds) {

	unsigned int n=0;
	const unsigned int size=bufferSize/_settings.precision;
	FXshort* buf=(FXshort*)buffer;
	do {
		if (_bufIndex>=_bufLen) {
#ifdef SV8
			mpc_frame_info frame;
			frame.buffer=_buffer;
			const mpc_status err=mpc_demux_decode(_demux, &frame);
			if (frame.bits==-1)
				break;
			if (err!=MPC_STATUS_OK) {
				fxmessage("Decoding error\n");
				return 0;
			}

			_bufLen=frame.samples*_si.channels;
#else
			_bufLen=mpc_decoder_decode(&_decoder, _buffer, 0, 0)*_si.channels;
			if (!_bufLen)
				break;
			if (_bufLen<0) {
				fxmessage("Decoding error\n");
				return 0;
			}
#endif
			_bufIndex=0;
		}

		for (unsigned int j=0; j<_si.channels; j++) {
			if (_settings.precision==2)
				buf[n++]=_quant->get16((void*)&_buffer[_bufIndex++], j);
			else
				buffer[n++]=_quant->get8((void*)&_buffer[_bufIndex++], j);
		}
	} while (n<size);

	return (n*_settings.precision);
}

/*****************************************************************/

bool mpc::supports(const char* fileName) {

	return FXPath::match(FXString(EXT), FXPath::name(fileName), FILEMATCH_FILE_NAME|FILEMATCH_NOESCAPE|FILEMATCH_CASEFOLD);
}

inline FXString mpc::ext() const { return FXString(EXT); }

mpc::mpc(FXApp* a) :
	inputPlugin(a, name, iconMpc),
	_quant(0) {

	_settings.precision=(load("Bits", 16)>>3);

	_mpcReader.read=mpc::read_func;
	_mpcReader.seek=mpc::seek_func;
	_mpcReader.tell=mpc::tell_func;
	_mpcReader.get_size=mpc::get_size_func;
	_mpcReader.canseek=mpc::canseek_func;
	_mpcReader.data=&_file;
}

mpc::~mpc() {

	close();

	save("Bits", _settings.precision<<3);
}

bool mpc::open(const FXString& fileName) {

	close();

	if (!_file.open(fileName))
		return false;

	const tag* tagPtr=new tag(&_file);

	addInfo(TITLE, tagPtr->title());
	addInfo(ARTIST, tagPtr->artist());
	addInfo(ALBUM, tagPtr->album());
	addInfo(GENRE, tagPtr->genre());
	addInfo(YEAR, tagPtr->year());
	addInfo("Publisher", tagPtr->publisher());
	addInfo(TRACK, tagPtr->track());
	addInfo(COMMENT, tagPtr->comment());

	delete tagPtr;

#ifdef SV8
	_demux=mpc_demux_init(&_mpcReader);
	if (!_demux) {
		close();
		return false;
	}

	mpc_demux_get_info(_demux, &_si);
#else
	mpc_streaminfo_init(&_si);
	if (mpc_streaminfo_read(&_si, &_mpcReader)!=ERROR_CODE_OK) {
		close();
		return false;
	}

	mpc_decoder_setup(&_decoder, &_mpcReader);
	if (!mpc_decoder_initialize(&_decoder, &_si)) {
		close();
		return false;
	}
#endif

	time((FXint)mpc_streaminfo_get_length(&_si));

#ifdef MPC_FIXED_POINT
	_quant=new requantizeInt(_settings.precision, MPC_FIXED_POINT_SCALE_SHIFT);
#else
	_quant=new requantizeFloat();
#endif

	_bufIndex=0;
	_bufLen=0;

	songLoaded(true);
	return true;
}

void mpc::close() {

	_file.close();

	delPtr(_quant);

#ifdef SV8
	if (songLoaded())
		mpc_demux_exit(_demux);
#endif

	songLoaded(false);
}

const bool mpc::rewind() {

#ifdef SV8
	if (!mpc_demux_seek_sample(_demux, 0))
#else
	 if (!mpc_decoder_seek_seconds(&_decoder, 0))
#endif
		return false;

	_bufIndex=0;
	_bufLen=0;

	return true;
}

const bool mpc::config(FXWindow* win) {

	mpcConfig cWin(win, _settings);
	if (cWin.execute(PLACEMENT_OWNER)) {
		_settings=cWin.settings();
		return true;
	}
	return false;
}

mpc_int32_t mpc::read_func(DATAPARM, void *ptr, mpc_int32_t size) {

	return ((FXFile*)DATAFILE)->readBlock((char*)ptr, size);
}

mpc_bool_t mpc::seek_func(DATAPARM, mpc_int32_t offset) {

	((FXFile*)DATAFILE)->position(offset);
	return true;
}

mpc_int32_t mpc::tell_func(DATAPARM) {

	return ((FXFile*)DATAFILE)->position();
}

mpc_int32_t mpc::get_size_func(DATAPARM) {

	return ((FXFile*)DATAFILE)->size();
}

mpc_bool_t mpc::canseek_func(DATAPARM) {

	return true;
}

/*****************************************************************/

FXDEFMAP(mpcConfig) mpcConfigMap[] = {
	// Message_Type		ID				Message_Handler
	FXMAPFUNC(SEL_COMMAND,	mpcConfig::ID_BITS,		mpcConfig::onCmdBits),
};

FXIMPLEMENT(mpcConfig, configWindow, mpcConfigMap, ARRAYNUMBER(mpcConfigMap))

mpcConfig::mpcConfig(FXWindow* win, mpcConfig_t settings) :
	configWindow(win, mpc::name, CREDITS, LINK),
	_settings(settings) {

	FXint val;

	new FXLabel(matrix(), tr("Bits"), 0, LAYOUT_FILL|JUSTIFY_RIGHT);
	FXListBox *_bitBox=new FXListBox(matrix(), this, mpcConfig::ID_BITS, LAYOUT_FILL|FRAME_NORMAL);
	_bitBox->fillItems("8\n16");
	_bitBox->setNumVisible(2);
	switch (_settings.precision) {
	case 1:
		val=0;
		break;
	default:
	case 2:
		val=1;
		break;
	}
	_bitBox->setCurrentItem(val);

}

long mpcConfig::onCmdBits(FXObject*, FXSelector, void* ptr) {

	const FXint val=(FXint)(FXival)ptr;
	switch (val) {
	case 0:
		_settings.precision=1;
		break;
	case 1:
		_settings.precision=2;
		break;
	}
	return 1;
}

#endif
