/*
 *  Copyright (C) 2006-2009 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef OSS_H
#define OSS_H

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#if defined (HAVE_SYS_SOUNDCARD_H) || defined (HAVE_MACHINE_SOUNDCARD_H)

#include <fx.h>

#include "outputPlugin.h"

/*****************************************************************/

/**
 * OSS output backend
*/
class oss : public outputPlugin {

private:
	int	_audioHandle;

	char	*_buffer;

private:
	void testDevice(const FXchar* devName);

	const int setParams(int &sampleRate, const int channels, const int prec);

public:
	oss(FXApp* app);
	virtual ~oss() {};

	static const char name[];

	/// Factory method
	static output* factory(FXApp* a) { return new oss(a); }

	/// Open
	int open(const int card, int &sampleRate, const int channels, const int prec);

	/// Close
	void close();

	/// Get buffer
	char *buffer() { return _buffer; }

	/// Write data to output
	bool write(char* buffer, int bufferSize);

	/// Pause
	void pause();

	/// Set volume
	void volume(int vol);
};

#endif

#endif
