/*
 *  Copyright (C) 2006-2008 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "AboutDialog.h"
#include "info.h"
#include "credits.h"
#include "iconFactory.h"
#include "LinkLabel.h"

/* created by reswrap from file foxbig.gif */
const unsigned char icon_foxbig[208]={
  0x47,0x49,0x46,0x38,0x37,0x61,0x20,0x00,0x20,0x00,0xc2,0x00,0x00,0xff,0xff,0xff,
  0x8e,0x8e,0x8e,0x00,0x00,0x00,0x49,0x49,0x55,0x24,0x24,0x00,0x24,0x24,0x55,0x00,
  0x00,0x00,0x00,0x00,0x00,0x2c,0x00,0x00,0x00,0x00,0x20,0x00,0x20,0x00,0x00,0x03,
  0x9d,0x08,0xba,0xdc,0xfe,0x30,0xca,0x49,0x6b,0x0d,0x42,0x04,0x90,0x75,0xc4,0x19,
  0xd4,0x65,0xdb,0x28,0x0c,0x8d,0x29,0x3c,0x6a,0xa9,0x2e,0xea,0xda,0x10,0xdd,0xe6,
  0x80,0xe1,0x68,0xdf,0xdd,0x14,0x4b,0x3d,0x8a,0x49,0x02,0xda,0xc1,0x42,0x0b,0x9c,
  0xd1,0x51,0x4b,0x8d,0x18,0xc1,0xc8,0x8b,0x63,0x22,0x1c,0x65,0xd2,0x21,0x55,0xbb,
  0xf5,0x69,0x7f,0x8a,0xa8,0x08,0x09,0x7d,0x2a,0x94,0x40,0x72,0x19,0x0b,0x28,0x74,
  0xac,0x59,0xf6,0xc7,0xb4,0x5c,0x53,0x94,0x4d,0x96,0x9a,0xd7,0xc4,0x11,0xea,0x62,
  0x6b,0x79,0x00,0x38,0x62,0x81,0x57,0x1e,0x7c,0x6a,0x87,0x61,0x24,0x73,0x7b,0x16,
  0x91,0x92,0x1c,0x61,0x30,0x12,0x70,0x3e,0x95,0x33,0x4c,0x34,0x5b,0x2b,0x27,0x48,
  0x32,0x9f,0x94,0x87,0x70,0xa2,0x94,0xa8,0xa2,0xa7,0xa8,0x9b,0xa9,0xae,0xa9,0xab,
  0x72,0x8d,0x9e,0xb4,0xae,0xa3,0x54,0x93,0xb9,0xba,0xbb,0xbc,0x0c,0x09,0x00,0x3b
  };

/* created by reswrap from file drf.gif */
const unsigned char icon_drf[133]={
  0x47,0x49,0x46,0x38,0x39,0x61,0x10,0x00,0x10,0x00,0xf2,0x00,0x00,0x15,0x15,0x15,
  0x00,0xff,0x00,0x00,0xff,0xff,0xff,0xff,0x00,0xc6,0xc6,0xc6,0xcc,0xcc,0xcc,0x00,
  0x00,0x00,0x00,0x00,0x00,0x21,0xf9,0x04,0x01,0x00,0x00,0x05,0x00,0x2c,0x00,0x00,
  0x00,0x00,0x10,0x00,0x10,0x00,0x00,0x03,0x4a,0x08,0xba,0xdc,0x2a,0x30,0xbe,0x08,
  0x1f,0x13,0x76,0x61,0x80,0x0b,0x07,0x5e,0xe7,0x69,0xe0,0x17,0x82,0x45,0x7a,0x72,
  0xdd,0xb7,0xa4,0x40,0xa0,0xc8,0x70,0x60,0xd3,0x9e,0x1c,0xa3,0xfb,0x9b,0xc7,0xb8,
  0x9d,0xaa,0x26,0x24,0x2a,0x54,0x80,0x81,0x12,0xe5,0x51,0x0e,0x98,0xc9,0x27,0xac,
  0x29,0x45,0x2e,0x3d,0xb0,0xab,0x55,0x7a,0x8c,0x32,0x9b,0xbc,0xec,0x77,0x54,0xc2,
  0xfa,0x54,0x09,0x00,0x3b
  };

FXIMPLEMENT(aboutDialog, FXDialogBox, 0, 0)

aboutDialog::aboutDialog(FXWindow* win, FXIcon *icon) :
	FXDialogBox(win, FXString::null, DECOR_TITLE|DECOR_BORDER, 0,0,0,0, 0,0,0,0, 0,0) {

	setTitle(FXStringFormat("%s %s", tr("About "), PACKAGE_NAME));

	FXHorizontalFrame* buttons=new FXHorizontalFrame(this, LAYOUT_FILL_X|FRAME_SUNKEN|PACK_UNIFORM_WIDTH, 0,0,0,0, 0,0,0,0, 0,0);

	FXSwitcher* switcher=new FXSwitcher(this, LAYOUT_FILL_X, 0,0,0,0, 0,0,0,0);

	new FXButton(buttons, tr("&Info"), 0, switcher, FXSwitcher::ID_OPEN_FIRST+0, FRAME_RAISED|LAYOUT_FILL_X);
	new FXButton(buttons, tr("C&ontact"), 0, switcher, FXSwitcher::ID_OPEN_FIRST+1, FRAME_RAISED|LAYOUT_FILL_X);
	new FXButton(buttons, tr("C&redits"), 0, switcher, FXSwitcher::ID_OPEN_FIRST+2, FRAME_RAISED|LAYOUT_FILL_X);
	new FXButton(buttons, tr("&Fox"), 0, switcher, FXSwitcher::ID_OPEN_FIRST+3, FRAME_RAISED|LAYOUT_FILL_X);
	new FXButton(buttons, tr("&License"), 0, switcher, FXSwitcher::ID_OPEN_FIRST+4, FRAME_RAISED|LAYOUT_FILL_X);

	// Info
	FXVerticalFrame* frame=new FXVerticalFrame(switcher, LAYOUT_FILL, 0,0,0,0, 15,15,15,15);
	new FXLabel(frame,
		FXStringFormat("%s\n\n%s %s \n\n%s \302\251 %s %s", PACKAGE_NAME, tr("Version"),
			PACKAGE_VERSION, tr("Copyright"), YEAR, AUTHOR),
		icon, LAYOUT_FILL_X|JUSTIFY_HZ_APART|ICON_AFTER_TEXT);

	// Contact
	frame=new FXVerticalFrame(switcher, LAYOUT_FILL, 0,0,0,0, 15,15,15,15);
	new FXLinkLabel(frame, FXString(WEBSITE));
	new FXLabel(frame, FXStringFormat("%s: %s", tr("E-mail"), PACKAGE_BUGREPORT));

	// Credits
	frame=new FXVerticalFrame(switcher, FRAME_SUNKEN|LAYOUT_FILL, 0,0,0,0, 0,0,0,0);
	FXScrollWindow* sw=new FXScrollWindow(frame, LAYOUT_FILL);
	new FXLabel(sw, FXString(CREDITS), 0, LAYOUT_FILL);

	// Fox
	frame=new FXVerticalFrame(switcher,LAYOUT_FILL, 0,0,0,0, 15,15,15,15);
	new FXLabel(frame,
		FXStringFormat("%s\n\n%s %d.%d.%d",
			tr("Using the FOX C++ GUI Library"),
			tr("Version"), fxversion[0], fxversion[1], fxversion[2]),
		GET_ICON(getApp(), icon_foxbig), LAYOUT_FILL |JUSTIFY_HZ_APART|ICON_AFTER_TEXT);
	new FXLinkLabel(frame, FXString("http://www.fox-tookit.org"));

	// License
	frame=new FXVerticalFrame(switcher, FRAME_SUNKEN|LAYOUT_FILL, 0,0,0,0, 0,0,0,0);
	FXText* text=new FXText(frame, 0, 0, TEXT_READONLY|TEXT_WORDWRAP|LAYOUT_FILL);
	text->setText(LICENSE_SHORT, strlen(LICENSE_SHORT));

	new FXSeparator(this);
	FXHorizontalFrame* closebox=new FXHorizontalFrame(this, LAYOUT_FILL, 0,0,0,0);
	new FXLabel(closebox, FXString::null, GET_ICON(getApp(), icon_drf));
	new FXButton(closebox, tr("&Close"), GET_ICON(getApp(), icon_dialogcancel), this, FXDialogBox::ID_CANCEL,
		BUTTON_INITIAL|BUTTON_DEFAULT|BUTTON_NORMAL|LAYOUT_RIGHT);
}
