/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

// Based on code posted by Rafael de Pelegrini Soares on the Fox-toolkit mailing list

#ifndef LINKLABEL_H
#define LINKLABEL_H

#include <fx.h>

/**
* A label which points to a link.
* This class behaves very much like the FXLabel class but it
* points to some link which is started when clicked.
*/

class FXLinkLabel : public FXLabel {
  FXDECLARE(FXLinkLabel)
private:
  FXLinkLabel(){}
  bool fxexecute(const FXString& link);
public:
  /// Construct a link label
  FXLinkLabel(FXComposite* p,const FXString& text,FXIcon* ic=0,FXuint opts=LABEL_NORMAL,FXint x=0,FXint y=0,FXint w=0,FXint h=0,FXint pl=DEFAULT_PAD,FXint pr=DEFAULT_PAD,FXint pt=DEFAULT_PAD,FXint pb=DEFAULT_PAD);

  /// Destroy the link label
  virtual ~FXLinkLabel();

  // FOX enum
 enum {
    ID_TIMER=FXLabel::ID_LAST,
    ID_LAST
    };

  // FOX messages
  long onLeftBtnPress(FXObject*,FXSelector,void*);
  long onEnter(FXObject*,FXSelector,void*);
  long onLeave(FXObject*,FXSelector,void*);
  long onTimer(FXObject*,FXSelector,void*);
};

#endif
