/*
 *  Copyright (C) 2006-2008 Leandro Nini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef INFODIALOG_H
#define INFODIALOG_H

#include <fx.h>
#include "input.h"

class textLabel : public FXLabel {
	FXDECLARE(textLabel)

private:
	textLabel() {};
	textLabel(const textLabel&);
	textLabel &operator=(const textLabel&);

public:
	/// Construct label with given text
	textLabel(FXComposite* p, const FXString& text, FXuint opts=LABEL_NORMAL) :
		FXLabel(p, FXString::null, 0, opts) { label=text; }
};

/*****************************************************************/

class infoDialog : public FXDialogBox {
	FXDECLARE(infoDialog)

private:
	FXFont	*_font;
	FXImage *_img;

private:
	infoDialog() {};
	infoDialog(const infoDialog&);
	infoDialog& operator=(const infoDialog&);

public:
	infoDialog(FXWindow* win, input* i, const char* folder=0);
	virtual ~infoDialog();
};

#endif
